from __future__ import print_function
from PIL import Image
from benchpress import util
import numpy as np
from bohrium.stdviews import cartesian

def apply_filter(size, weight):
    """TODO: And what does this one do?"""

    kernel      = np.zeros((size, size))
    totalsum    = 0
    kernelrad   = size/2
    distance    = 0
    caleuler    = 1.0 /(2.0 * np.pi * weight**2)

    for filterY in range(-kernelrad, kernelrad+1, 1): 
        for filterX in range(-kernelrad, kernelrad+1, 1): 
            distance = ((filterX * filterX)+(filterY*filterY))/(2 * (weight * weight)) 
            kernel[filterY + kernelrad,filterX + kernelrad] = caleuler * np.exp(-distance) 
            totalsum += kernel[filterY + kernelrad, filterX + kernelrad] 
    kernel *= (1.0/totalsum)

    return kernel

def convolve_init(fsize, photo='/tmp/Hell.jpg'):
    """TODO: Describe the data loaded/generated by this function."""

    img     = Image.open(photo)
    rgb     = np.array(img)
    tones   = np.array((0.3, 0.6, 0.11))
    rgb     = np.add.reduce((rgb*tones[np.newaxis, np.newaxis, :]), axis=2)
    kernel  = apply_filter(fsize, 13.0)

    return (rgb, kernel)

def convolve(image, image_filter):
    """TODO: Describe the benchmark."""
    
    views   = cartesian(image, len(image_filter))
    result  = sum(d[0]*d[1] for d in zip(views, image_filter.flatten()))

    return result

def main():
    """
    Example parameter: --size=25.
    This will execute on a something related to 25....
    """
    B = util.Benchmark()
    (N,) = B.size
    image, image_filter = convolve_init(N)
    
    B.start()
    result = convolve(image, image_filter)
    B.stop()
    B.pprint()

if __name__ == "__main__":
    main()
