from __future__ import print_function
from PIL import Image
from benchpress import util
import numpy as np
from bohrium.stdviews import cartesian

def gen_2d_filter(size, weight, datatype=np.float32):
    """TODO: And what does this one do?"""

    kernel      = np.zeros((size,size), dtype=datatype)
    totalsum    = 0
    kernelrad   = size / 2
    distance    = 0
    caleuler    = 1.0 / (2.0 * np.pi * weight**2)

    for filterY in range(-kernelrad, kernelrad+1, 1): 
        for filterX in range(-kernelrad, kernelrad+1, 1): 
            distance = ((filterX * filterX)+(filterY*filterY))/(2 * (weight * weight)) 
            kernel[filterY + kernelrad,filterX + kernelrad] = caleuler * np.exp(-distance) 
            totalsum += kernel[filterY + kernelrad, filterX + kernelrad] 
    kernel *= (1.0/totalsum)

    return kernel

def convolve_2d_init(fsize, photo='/tmp/Hell.jpg', datatype=np.float32):
    """TODO: Describe the data loaded/generated by this function."""

    img     = Image.open(photo)
    rgb     = np.array(img, dtype=datatype)
    tones   = np.array((0.3, 0.6, 0.11), dtype=datatype)
    rgb     = np.add.reduce((rgb*tones[np.newaxis, np.newaxis, :]), axis=2)
    kernel  = gen_2d_filter(fsize, 13.0)

    return rgb, kernel

def convolve_2d(image, image_filter):
    """TODO: And what do we have here?"""

    views = cartesian(image, len(image_filter))
    return sum(d[0]*d[1] for d in zip(views, image_filter.flatten()))

def main():
    """
    Example parameter: --size=25.
    This will execute on a something related to 25....
    """
    B = util.Benchmark()        # Benchmark setup
    (N,) = B.size
    image, image_filter = convolve_2d_init(N)
    image + 1, image_filter + 1 # Ensure arrays are in the correct space.

    B.start()                   # Benchmark run / timing
    result = convolve_2d(image, image_filter)
    B.stop()
    B.pprint()

if __name__ == "__main__":
    main()
